//=============================================================================
// Mega128 EVM Module Test Program
// by nexp76(nexp76@naver.com) http://cafe.naver.com/elab
// [tcps1.c]
//=============================================================================

/*
 - [W5100] EVM Tcp Server Test Program
 - MY_LISTEN_PORT(5000)  Ͽ   ø ǥ 
*/

#include "..\00_hal\system.h"
#include "..\01_drv\serial.h"

#include "../01_drv/wiznet/mcu/types.h"
#include "../01_drv/wiznet/iinchip/w5100.h"
#include "../01_drv/wiznet/iinchip/socket.h"
#include "../01_drv/wiznet/iinchip/wiznet.h"


//-----------------------------------------------------------------------------
#define MY_NET_MAC			{0x00, 0x08, 0xdc, 0x00, 0x00, 0x00}		// MY Mac Address : 00.08.DC.00.00.00

#define MY_NET_GWIP			{192,  168, 0,    1}	// MY Gateway IP    : 192.168.0.1
#define MY_DESTINATIONIP	{192,  168, 0,  154}	// MY Destination   : 192.168.0.154
#define MY_SOURCEIP			{192,  168, 0,  100}	// MY Source IP     : 192.168.0.100
#define MY_SUBNET			{255, 255, 255,   0}

#define MY_NET_MEMALLOC		0x55					// MY iinchip memory allocation

#define MY_LISTEN_PORT		5000					// MY Listen Port  : 5000 
#define MY_CONNECT_PORT		3000					// MY Connect Port : 3000

#define TX_RX_MAX_BUF_SIZE	1024
#define SOCK_TCPC			0
#define SOCK_TCPS			1
//-----------------------------------------------------------------------------


unsigned char m_dip[4]	= MY_DESTINATIONIP;			//Destination IP	: 192.168.0.154
unsigned char m_sip[4]	= MY_SOURCEIP;				//Source IP     	: 192.168.0.100

//-----------------------------------------------------------------------------
void NetInit(void)
{
	unsigned char mac[6]	= MY_NET_MAC;
	unsigned char sm[4]	= MY_SUBNET;
	unsigned char gwip[4]	= MY_NET_GWIP;

	//W5100 Chip Init
	iinchip_init();

	//Set MAC Address
	setSHAR(mac);

	//Set Gateway
	setGAR(gwip);

	//Set Subnet Mask
	setSUBR(sm);

	//Set My IP
	setSIPR(m_sip);
	
#ifdef __DEF_IINCHIP_INT__
	setIMR(0xEF);
#endif
	
	sysinit(MY_NET_MEMALLOC, MY_NET_MEMALLOC);
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//Initialize socket -    ʱȭ
unsigned char InitSocketServer(unsigned int Socket, unsigned Port)
{
	//initialize the socket 
	if(socket(Socket,Sn_MR_TCP, Port,0x20) == 0)
	{
		DebugPrint("Fail to create socket.");

		return 0;
	}
	else
	{
		listen(Socket);
	}

	return 1;
}

//-----------------------------------------------------------------------------
//ŵ ó
void EthernetTest(unsigned char *pRcvBuffer, unsigned int len)
{
	unsigned int i;

	DebugPrint("Read Data[%d]\r\n", len);
	
	for(i=0;i<len;i++)
	{
		//if(i%16==0)DebugPrint("\r\n");
		DebugPrint("%c", pRcvBuffer[i]);
	}

	DebugPrint("\r\nReceive OK!\r\n");
}


//TCP-Server ó
void ProcessTcpSever(void)
{
	int len;							
	unsigned char data_buf[TX_RX_MAX_BUF_SIZE];

	uint16 port = MY_LISTEN_PORT;
	
	switch (getSn_SR(SOCK_TCPS))
	{
	case SOCK_ESTABLISHED:
		//check Rx data
		if((len = getSn_RX_RSR(SOCK_TCPS)) > 0) 			
		{
			//if Rx data size is lager than TX_RX_MAX_BUF_SIZE 
			if (len > TX_RX_MAX_BUF_SIZE) len = TX_RX_MAX_BUF_SIZE;	
			
			//read the received data
			len = recv(SOCK_TCPS, data_buf, len);

			//send the received data - loop back test
			send(SOCK_TCPS, data_buf, len);	
			
			EthernetTest(data_buf, len);
		}		
		break;
		
	case SOCK_CLOSE_WAIT:                           		
		//If the client request to close
		disconnect(SOCK_TCPS);
		break;
		
	case SOCK_CLOSED:
		//if a socket is closed
		
		//reinitialize the socket 
		InitSocketServer(SOCK_TCPS, port);
		break;
	}
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Main Routine
//-----------------------------------------------------------------------------
int main(void)
{
	SystemInit();
	
	//Serial Init
	DebugInit(BAUD_115200);
	DebugPrint("[Mega128 EVM] Test Program. - TCP Server\r\n");

	Led1Init();
	Led1Off();
	
	Led2Init();
	Led2On();

	//W5100 Chip Initialize
	//----------------------------
	InitWiznet();

	NetInit();
	//----------------------------
	
	//Display Net Configuration..
	DisplayConfig();
	
	//Initialize TCP Server
	InitSocketServer(SOCK_TCPS, MY_LISTEN_PORT);
	
	while (1)
	{
		//TCP Server Process
		ProcessTcpSever();
	}		
}
//-----------------------------------------------------------------------------
